﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Input
Imports System.Math

Public Class clPadStatus

    Shared Sub getcmd(ByRef status As Integer, ByRef LX As Single, ByRef LY As Single _
                       , ByRef arm_dx As Integer, ByRef arm_dy As Integer, ByRef arm_dz As Integer)

        Dim currentState As GamePadState = GamePad.GetState(PlayerIndex.One)

        status = 0

        arm_dx = 100
        arm_dy = 100
        arm_dz = 100

        LX = currentState.ThumbSticks.Left.X.ToString
        LY = currentState.ThumbSticks.Left.Y.ToString

        With currentState
            '前進
            If currentState.ThumbSticks.Left.Y > 0.3 And Abs(currentState.ThumbSticks.Left.X) < 0.2 Then status = 1
            '後進
            If currentState.ThumbSticks.Left.Y < -0.3 And Abs(currentState.ThumbSticks.Left.X) < 0.2 Then status = 2
            '微右旋回
            If currentState.ThumbSticks.Left.Y > 0.3 And currentState.ThumbSticks.Left.X >= 0.2 Then status = 3
            '微左旋回
            If currentState.ThumbSticks.Left.Y > 0.3 And currentState.ThumbSticks.Left.X <= -0.2 Then status = 4
            '信地旋回　右早
            If Abs(currentState.ThumbSticks.Left.Y) <= 0.3 And currentState.ThumbSticks.Left.X > 0.6 Then status = 5
            '信地旋回　左早
            If Abs(currentState.ThumbSticks.Left.Y) <= 0.3 And currentState.ThumbSticks.Left.X < -0.6 Then status = 6
            '信地旋回　右早
            If Abs(currentState.ThumbSticks.Left.Y) <= 0.3 And currentState.ThumbSticks.Left.X <= 0.6 And currentState.ThumbSticks.Left.X > 0.2 Then status = 7
            '信地旋回　左早
            If Abs(currentState.ThumbSticks.Left.Y) <= 0.3 And currentState.ThumbSticks.Left.X >= -0.6 And currentState.ThumbSticks.Left.X < -0.2 Then status = 8

            If status = 0 Then
                If currentState.Buttons.Y = ButtonState.Pressed Then
                    '一歩だけ歩くモード
                    If currentState.DPad.Up = ButtonState.Pressed Then status = 9
                    If currentState.DPad.Down = ButtonState.Pressed Then status = 10
                    If currentState.DPad.Right = ButtonState.Pressed Then status = 11
                    If currentState.DPad.Left = ButtonState.Pressed Then status = 12
                Else
                    'その場で方向微調整モード
                    If currentState.DPad.Right = ButtonState.Pressed Then status = 13
                    If currentState.DPad.Left = ButtonState.Pressed Then status = 14
                    If currentState.DPad.Up = ButtonState.Pressed Then status = 15
                End If
            End If

            'アームリモコンモード
            If currentState.Triggers.Right > 0 Then
                status = 99
                arm_dx = Int(currentState.ThumbSticks.Right.Y * 100.0) + 100
                arm_dy = -Int(currentState.ThumbSticks.Left.X * 100.0) + 100
                arm_dz = Int(currentState.ThumbSticks.Left.Y * 100.0) + 100
            End If
        End With

    End Sub


End Class
